/*
 * Utility functions
 */
#include <time.h>
#include <string.h>

#include "libfma.h"
#include "lf_internal.h"

/*
 * Return a timestamp string.  This is a static string.
 */
char *
lf_timestamp()
{
  time_t now;
  static lf_string_t str;

  time(&now);
  strcpy(str, asctime(localtime(&now)));
  str[strlen(str)-1] = '\0';
  return str;
}

/*
 * Convert a string to a MAC address
 */
void
lf_string_to_mac(
  lf_mac_addr_t mac_addr,
  char *mac_str)
{
  int int_mac[6];
  int i;

  sscanf(mac_str, LF_MAC_FORMAT,
      &int_mac[0],
      &int_mac[1],
      &int_mac[2],
      &int_mac[3],
      &int_mac[4],
      &int_mac[5]);

  for (i=0; i<6; ++i) {
    mac_addr[i] = int_mac[i];
  }
}
